CMSIS DSP Software Library: Vector Absolute Value

Functions

# Vector Absolute Value
[Basic Math Functions]

## Functions
void | arm_abs_f32 (float32_t *pSrc, float32_t *pDst, uint32_t blockSize)
void | arm_abs_q31 (q31_t *pSrc, q31_t *pDst, uint32_t blockSize)
void | arm_abs_q15 (q15_t *pSrc, q15_t *pDst, uint32_t blockSize)
void | arm_abs_q7 (q7_t *pSrc, q7_t *pDst, uint32_t blockSize)

## Detailed Description

Computes the absolute value of a vector on an element-by-element basis.

         pDst[n] = abs(pSrcA[n]),   0 <= n < blockSize.

The operation can be done in-place by setting the input and output pointers to the same buffer. There are separate functions for floating-point, Q7, Q15, and Q31 data types.

## Function Documentation

void arm_abs_f32 | ( | float32_t * | pSrc,
|  | float32_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Floating-point vector absolute value.

Parameters:

  [in] | *pSrc | points to the input buffer
  [out] | *pDst | points to the output buffer
  [in] | blockSize | number of samples in each vector

Returns:
  none.

Examples:
  arm_signal_converge_example_f32.c.

Definition at line 66 of file arm_abs_f32.c.

void arm_abs_q31 | ( | q31_t * | pSrc,
|  | q31_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Q31 vector absolute value.

Parameters:

  [in] | *pSrc | points to the input buffer
  [out] | *pDst | points to the output buffer
  [in] | blockSize | number of samples in each vector

Returns:
  none.

Scaling and Overflow Behavior:

  The function uses saturating arithmetic. The Q31 value -1 (0x80000000) will be saturated to the maximum allowable positive value 0x7FFFFFFF.

Definition at line 58 of file arm_abs_q31.c.

void arm_abs_q15 | ( | q15_t * | pSrc,
|  | q15_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Q15 vector absolute value.

Parameters:

  [in] | *pSrc | points to the input buffer
  [out] | *pDst | points to the output buffer
  [in] | blockSize | number of samples in each vector

Returns:
  none.

Scaling and Overflow Behavior:

  The function uses saturating arithmetic. The Q15 value -1 (0x8000) will be saturated to the maximum allowable positive value 0x7FFF.

Definition at line 57 of file arm_abs_q15.c.

void arm_abs_q7 | ( | q7_t * | pSrc,
|  | q7_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Q7 vector absolute value.

Parameters:

  [in] | *pSrc | points to the input buffer
  [out] | *pDst | points to the output buffer
  [in] | blockSize | number of samples in each vector

Returns:
  none.

Scaling and Overflow Behavior:

  The function uses saturating arithmetic. The Q7 value -1 (0x80) will be saturated to the maximum allowable positive value 0x7F.

Definition at line 57 of file arm_abs_q7.c.

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Defines